-- Standard values
if(PVPRole_SV == nil) then
    resetVars();
end

local name = "PVPRoles"
PVPRoles = LibStub("AceAddon-3.0"):NewAddon(name, "AceConsole-3.0");

-- get Information about TargetFrame
local left = TargetFrame:GetWidth() + PVPRole_SV.left;
local top = -1 * PVPRole_SV.top;

specRole = {};
currentRole = 0;


local f = CreateFrame("frame", "Rolle", UIParent);
f:RegisterEvent("PLAYER_TARGET_CHANGED");

f:SetFrameStrata("BACKGROUND");
f:SetWidth(64);
f:SetHeight(64);
f:SetScript("OnEvent",function(s,event,a)
    f:SetPoint("TOPLEFT", TargetFrame,"TOPLEFT",left,top);
    -- Generally Hide
    f:Hide();
    -- check if player in bg
    if(select(2, IsInInstance()) == "pvp") then
        local currentRole = 0;
        if(UnitIsPlayer("target")  == true) then
            debug("target is player");
            local playersInBattlefield = GetNumBattlefieldScores();		-- num of players in bg
            local targetName, targetRealm = UnitName("target");

            if(targetName and targetRealm) then
                targetName = targetName .."-".. targetRealm;
            end
            debug("Target: " .. targetName);

            for i = 1, playersInBattlefield, 1 do -- check all players in battleground stats
            -- all the fucking shit to get programm working
            local name, _, _, _, _, faction, _, _, _, _, _, _, _, _, _, talentSpec = GetBattlefieldScore(i);
            debug(name .. " >> " .. faction .. " >> x" .. talentSpec);
            if(name == targetName) then
                if(PVPRole_SV.printSpec == 1) then
                    sendMsg(talentSpec);
                end
                debug(talentSpec);
                -- set extract active role out of talent spec
                currentRole = getRoleForLocaleSpec(talentSpec);
                debug(currentRole);
                break;
            end
            end
        end

        debug(currentRole);
        if(currentRole == 0) then
            return;
        end

        f:SetBackdrop({bgFile = getIconForRole(currentRole), 0, tile = false, tileSize = 0, edgeSize = 0, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
        f:Show();
    end
end);


function PVPRoles:SlashProcessor_PVPRoles(input)
    local command, paramList= input:match("^(%S*)%s*(.-)$")
    command = command:lower()
    local params = splitSpace(paramList);

    debug("Params: " .. command .. " " .. paramList);

    if(command == "debug") then
        local newDebug = 1
        if((params[1] == nil) == false and (tonumber(params[1]) == 1 or tonumber(params[1]) == 0)) then
            newDebug = tonumber(params[1]);
        else
            if(PVPRole_SV.debug == 0) then
                newDebug = 1;
            else
                newDebug = 0;
            end
        end
        setDebug(newDebug);
        sendMsg("Debugmode set to " .. newDebug);
    elseif(command == "reset") then
        resetVars();
        sendMsg("You set the settings to default");
    elseif(command == "reload") then
        loadLocaleSpecs();
        sendMsg("Speclist reloaded");
    elseif(command == "options") then
        debug("options called");
        if(params[1] == nil and params[2] == nil) then
            sendMsg("use it /pvproles options <option> <value>");
        else
            -- options
            -- iconset
            if(params[1]:lower() == "iconset") then
                if(existsSet(params[2]:lower())) then
                    setIconSet(params[2]:lower());
                    sendMsg("Your new IconSet is " .. iconSets[PVPRole_SV.iconSet]);
                else
                    sendMsg("Please choose between the existing iconSets: ")
                    for i=1, table.getn(iconSets), 1 do
                        sendMsg(iconSets[i]);
                    end
                    sendMsg("Your current set is " .. iconSets[PVPRole_SV.iconSet]);
                end
                -- printspec
            elseif(params[1]:lower() == "printspec") then
                if(tonumber(params[2]) == 0 or tonumber(params[2]) == 1) then
                    PVPRole_SV.printSpec = tonumber(params[2]);
                    if(tonumber(params[2]) == 0) then
                        sendMsg("Specs of your target will not be printed in chat.")
                    else
                        sendMsg("Specs of your target will now be printed in chat.")
                    end
                else
                    sendMsg("use it /pvproles options printspec [0|1]");
                    sendMsg("0: don't print spec\n1: print spec in chat");
                end

            end

        end

    end
end


local count = 0
function PVPRoles:OnInitialize()
    if count == 1 then
        debug("Init skipped");
        return
    end
    PVPRoles:RegisterChatCommand("PVPRoles", "SlashProcessor_PVPRoles");
    loadLocaleSpecs();
    debug("Init completed");
    count = 1;
end